
/**
 * Title:        Appia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia;

public class ChannelEventRoute {

  private Channel channel;
  private QoSEventRoute qosRoute;
  private Class eventType;
  private Session[] sessions;

  private boolean[] waypoints;
  private Session[] route;

  public ChannelEventRoute(Channel channel, QoSEventRoute qosRoute) {
    this.channel=channel;
    this.qosRoute=qosRoute;
    eventType=qosRoute.getEventType();
    sessions=channel.sessions;
    waypoints=qosRoute.waypoints;

    int size,i,j;

    for (size=0,i=0 ; i < sessions.length ; i++) {
      if (waypoints[i])
         size++;
    }

    route=new Session[size];

    for (i=0,j=0 ; i < sessions.length ; i++) {
      if (waypoints[i]) {
         route[j]=sessions[i];
         j++;
      }
    }
  }

  public Session[] getRoute() {
    return route;
  }

  public Class getEventType() {
    return eventType;
  }
}