
/**
 * Title:        Appia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia;

public class EventQualifier {

  public static final int ON=0;
  public static final int OFF=1;
  public static final int NOTIFY=2;

  private int qualifier;

  public EventQualifier() {
    qualifier=NOTIFY;
  }

  public EventQualifier(int qualifier) {
    this.qualifier=qualifier;
  }

  public void set(int qualifier) {
    this.qualifier=qualifier;
  }

  public int get() {
    return qualifier;
  }

  public boolean isOn() {
    return qualifier==ON;
  }

  public boolean isOff() {
    return qualifier==OFF;
  }

  public boolean isNotify() {
    return qualifier==NOTIFY;
  }
}