
/**
 * Title:        Appia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia;

public abstract class Layer {

  protected Class[] evAccept;
  protected Class[] evRequire;
  protected Class[] evProvide;

  public abstract Session createSession() ;

  public Class[] getProvidedEvents() {
    return (Class[])evProvide.clone();
  }

  public Class[] getRequiredEvents() {
    return (Class[])evRequire.clone();
  }

  public Class[] getAcceptedEvents() {
    return (Class[])evAccept.clone();
  }

  public void channelDispose(Session session, Channel channel) {}

}