
/**
 * Title:        Appia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia;

public class QoSEventRoute {

  private QoS qos;
  private Class eventType;
  private Layer[] layers;

  protected boolean[] waypoints;

  public QoSEventRoute(QoS qos, Class eventType) {
    this.eventType=eventType;
    this.qos=qos;

    Class[][] accepted=qos.eventsAccepted;
    layers=qos.layers;
    waypoints=new boolean[accepted.length];

    int i,j;
    for (i=0 ; i < accepted.length ; i++) {

      for (j=0 ; (j < accepted[i].length) && !(accepted[i][j].isAssignableFrom(eventType)) ; j++) ;

      waypoints[i]= (j < accepted[i].length) ;
    }
  }

  public Class getEventType() {
    return eventType;
  }

  public ChannelEventRoute makeChannelRoute(Channel channel) {
    return new ChannelEventRoute(channel,this);
  }
}