
package appia.events.channel;

import appia.*;

/**
 * Event that marks the end of {@link appia.Channel Channel} operation.
 *
 * @author Alexandre Pinto
 * @version 0.1
 * @see appia.events.channel.ChannelInit
 * @see appia.Channel#end
 */
public class ChannelClose extends ChannelEvent {

  /**
   * Creates a <b>initiated</b> <i>ChannelClose</i> event.
   *
   * @see appia.Event#init
   * @param channel the {@link appia.Channel Channel} where the event will be
   *                put.
   * @throws appiaEventException exception thrown if <i>channel</i> is null.
   */
  public ChannelClose(Channel channel) throws AppiaEventException {
    super(
      channel,
      new Direction(Direction.DOWN),
      null,
      new EventQualifier(EventQualifier.NOTIFY)
    );
  }
}