
package appia.events.channel;

import appia.*;

/**
 * Event that marks the beggining of {@link appia.Channel Channel} operation
 *
 * @author Alexandre Pinto
 * @version 0.1
 * @see appia.events.channel.ChannelClose
 * @see appia.Channel#start
 */
public class ChannelInit extends ChannelEvent {

  /**
   * Creates a <b>initiated</b> <i>ChannelInit</i> event
   *
   * @see appia.Event#init
   * @param channel the {@link appia.Channel Channel} where the event will be
   *                put.
   * @throws appiaEventException exception thrown if <i>channel</i> is null.
   */
  public ChannelInit(Channel channel) throws AppiaEventException {
    super(
      channel,
      new Direction(Direction.UP),
      null,
      new EventQualifier(EventQualifier.NOTIFY)
    );
  }
}