
/**
 * Title:        Appia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.events.channel;

import appia.*;

public class PeriodicTimer extends ChannelEvent implements Cloneable {

  public String timerID;
  protected long period=0;

  public PeriodicTimer() {}

  public PeriodicTimer(String timerID, long period,
                       Channel channel, Direction dir, Session source,
                       EventQualifier qualifier)
    throws AppiaEventException, AppiaException {

    super(channel,dir,source,qualifier);

    this.timerID=timerID;

    if ( period < 0 )
       throw new AppiaException("PeriodicTimer: period is negative");

    this.period=period;
  }

  public void setPeriod(long period) throws AppiaException {
    if ( period < 0 )
       throw new AppiaException("PeriodicTimer: period is negative");

    this.period=period;
  }

  public long getPeriod() {
    return period;
  }

  public Event cloneEvent() throws CloneNotSupportedException {
    return super.cloneEvent();
  }

}