
/**
 * Title:        Appia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.events.channel;

import appia.*;

public class Timer extends ChannelEvent {

  public String timerID;
  protected long when;

  public Timer() {}

  public Timer(String timerID, long when,
               Channel channel, Direction dir, Session source,
               EventQualifier qualifier)
    throws AppiaEventException, AppiaException {

    super(channel,dir,source,qualifier);

    this.timerID=timerID;

    if ( when < 0 )
       throw new AppiaException("Timer: when is negative");

    this.when=when;
  }

  public void setTimeout(long when) throws AppiaException {
    if ( when < 0 )
       throw new AppiaException("Timer: when is negative");

    this.when=when;
  }

  public long getTimeout() {
    return when;
  }

  public Event cloneEvent() throws CloneNotSupportedException {
    return super.cloneEvent();
  }

}