
/**
 * Title:        Apia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.message;

import java.io.ByteArrayInputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.io.StreamCorruptedException;

public class AppiaInputStream extends ByteArrayInputStream {

  public AppiaInputStream() {
    super(new byte[0]);
  }

  public void importMsgBuffer(MsgBuffer mbuf) {
    buf=mbuf.data;
    count=mbuf.len+mbuf.off;
    mark=pos=mbuf.off;
  }

  public int bytesRead() {
    return pos-mark;
  }

  public Object readObjectFromMessage(Message msg) throws IOException,ClassNotFoundException {
    MsgBuffer mbuf=new MsgBuffer();
    mbuf.len=msg.length();
    msg.peek(mbuf);

    buf=mbuf.data;
    count=mbuf.len+mbuf.off;
    mark=pos=mbuf.off;

    Object obj=(new ObjectInputStream(this)).readObject();

    msg.discard(pos-mark);

    return obj;
  }

  /////////////////////////

  public void mark(int readAheadLimit) {}
  public boolean markSupported() {
    return false;
  }
}