package appia.protocols.application;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework            //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: ApplicationLayer: Application interface for interaction   //
// with Appia                                                       //
//                                                                  //
// Author: Hugo Miranda, 06/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

import appia.*;
import appia.events.*;

public class ApplicationLayer extends Layer {

    public ApplicationLayer() {
	super();
    }

    public Class[] getProvidedEvents() {
	Class[] ret=new Class[5];
	try {
	    ret[0]=Class.forName("appia.protocols.udpsimple.RegisterSocketEvent");
	    ret[1]=Class.forName("appia.protocols.application.ApplSendEvent");
	    ret[2]=Class.forName("appia.events.channel.Debug");
	    ret[3]=Class.forName("appia.protocols.application.TestEvent");
	    ret[4]=Class.forName("appia.protocols.application.ReplyTestEvent");
	}
	catch(ClassNotFoundException ex) {
	    System.err.println("Class Not Found Exception in "+
			       "ApplicationLayer (getProvidedEvents). "+
			       "Check CLASSPATH information.");
	}
	return ret;
    }

    public Class[] getRequiredEvents() {
	Class[] ret=new Class[2];
	try {
	    //	    ret[1]=Class.forName("appia.events.channel.PeriodicTimer");
	    ret[0]=Class.forName("appia.protocols.application.ApplSendEvent");
	    ret[1]=Class.forName("appia.events.channel.AsyncEvent");

	}
	catch(ClassNotFoundException ex) {
	    System.err.println("Class Not Found Exception in "+
			       "ApplicationLayer (getRequiredEvents). "+
			       "Check CLASSPATH information.");
	}
	return ret;
    }

    public Class[] getAcceptedEvents() {
	Class[] ret=new Class[8];
	try {
	    ret[0]=Class.forName("appia.protocols.application.ApplSendEvent");
	    ret[1]=Class.forName("appia.events.channel.AsyncEvent");
	    ret[2]=Class.forName("appia.events.channel.ChannelInit");
	    ret[3]=Class.forName("appia.events.channel.ChannelClose");
	    ret[4]=Class.forName("appia.events.channel.Debug");
	    ret[5]=Class.forName("appia.protocols.application.TestEvent");
	    ret[6]=Class.forName("appia.protocols.application.ReplyTestEvent");
	    ret[7]=Class.forName("appia.protocols.fifo.FIFOUndelivered");
	}
	catch(ClassNotFoundException ex) {
	    System.err.println("Class Not Found Exception in "+
			       "ApplicationLayer (getAcceptedEvents). "+
			       "Check CLASSPATH information.");
	}
	
	return ret;
    }

    public Session createSession() {
	return new ApplicationSession(this);
    }

    public void channelDispose(Session session,Channel channel) {
    }
}
