package appia.protocols.drop;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework            //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: DropLayer: randomly drops outgoing sendable events        //
//                                                                  //
// Author: Hugo Miranda, 06/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

import appia.*;
import appia.events.*;

public class DropLayer extends Layer {

    public DropLayer() {
	super();
    }

    public Class[] getProvidedEvents() {
	return new Class[0];
    }

    public Class[] getRequiredEvents() {
	return new Class[0];
    }

    public Class[] getAcceptedEvents() {
	Class[] ret=new Class[1];
	try {
	    ret[0]=Class.forName("appia.events.SendableEvent");
	}
	catch(ClassNotFoundException ex) {
	    System.err.println("Class Not Found Exception in DropLayer. "+
			       "Check CLASSPATH information.");
	}
	
	return ret;
    }

    public Session createSession() {
	return new DropSession(this);
    }

    public void channelDispose(Session session,Channel channel) {
    }
}
