package appia.protocols.fifo;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework             //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: FIFOTimer: Timer event to be created and received by FIFO //
//                                                                  //
// Author: Hugo Miranda, 05/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

import appia.*;
import appia.events.channel.*;

public class FIFOTimer extends Timer {
    
    private WaitingMessage what;
    private PeerInfo       who;
    public  int            retry=0;

    public FIFOTimer(Channel c, Direction dir, Session gen, long when,
		     String timerID, WaitingMessage e, PeerInfo p)
	throws AppiaEventException, AppiaException {

	super(timerID,when,c,dir,gen,new EventQualifier(EventQualifier.ON));
	what=e;
	who=p;
    }

    public WaitingMessage getWait() {
	return what;
    }

    public PeerInfo getPeerInfo() {
	return who;
    }
}
