package appia.protocols.fifo;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework            //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: FIFOUndelivered. Event that notifies upper layers that    //
//        FIFO has not delivered one message to a peer.             //
//                                                                  //
// Author: Hugo Miranda, 10/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

import appia.*;

public class FIFOUndelivered extends Event {
    
    public Object who;

    public FIFOUndelivered(Channel c, Session gen, Object who)
	throws AppiaEventException {

	super(c,new Direction(Direction.UP),gen);
	this.who=who;
    }
}
