package appia.protocols.fifo;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework             //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: FifoLayer                                                 //
//                                                                  //
// Author: Hugo Miranda, 05/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

import appia.*;
import appia.protocols.*;
import appia.events.*;
import appia.events.channel.*;

public class FifoLayer extends Layer {

    private java.util.Vector sessions;

    public FifoLayer() {
	super();
	sessions=new java.util.Vector();
    }

    public Class[] getProvidedEvents() {
	Class[] ret=new Class[4];
	try {
	    ret[0]=Class.forName("appia.protocols.fifo.FIFOTimer");
	    ret[1]=Class.forName("appia.protocols.fifo.AckEvent");
	    ret[2]=Class.forName("appia.protocols.fifo.SendAckTimer");
	    ret[3]=Class.forName("appia.protocols.fifo.FIFOUndelivered");
	}
	catch(ClassNotFoundException ex) {
	    System.err.println("Class Not Found Exception in FifoLayer. "+
			       "Check CLASSPATH information.");
	}

	return ret;
    }

    public Class[] getRequiredEvents() {
	return new Class[0];
    }

    public Class[] getAcceptedEvents() {
	Class[] ret=new Class[7];
	try {
	    ret[0]=Class.forName("appia.events.SendableEvent");
	    ret[1]=Class.forName("appia.events.channel.ChannelInit");
	    ret[2]=Class.forName("appia.protocols.fifo.AckEvent");
	    ret[3]=Class.forName("appia.protocols.fifo.FIFOTimer");
	    ret[4]=Class.forName("appia.events.channel.Debug");
	    ret[5]=Class.forName("appia.protocols.fifo.SendAckTimer");
	    ret[6]=Class.forName("appia.protocols.frag.MaxPDUSizeEvent");
	}
	catch(ClassNotFoundException ex) {
	    System.err.println("Class Not Found Exception in FifoLayer. "+
			       "Check CLASSPATH information.");
	}
	
	return ret;
    }

    public Session createSession() {
	return new FifoSession(this);
    }

    public void channelDispose(Session session,Channel channel) {
    }

    public void linkChannelWithSession(Channel c, FifoSession s) {
    }
}
