package appia.protocols.fifo;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework             //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: FIFOTimer: Timer event to be created and received by FIFO //
//                                                                  //
// Author: Hugo Miranda, 05/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

import appia.*;
import appia.events.channel.*;

public class SendAckTimer extends Timer {
    
    public int      holdingSeqNumber;
    public PeerInfo peer;
    public Object   source; //The endpoint that will be the sender of the Ack

    public SendAckTimer(long when, Channel c, Session generator,PeerInfo peer,
			int holdingSeqNumber,Object source) 
	throws AppiaEventException, AppiaException {

	super("", when, c, new Direction(Direction.DOWN), 
	      generator, new EventQualifier(EventQualifier.ON));

	this.peer=peer;
	this.holdingSeqNumber=holdingSeqNumber;
	this.source=source;
    }
}
