package appia.protocols.fifo;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework            //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: WaitEvent : Keeps events and their sequence numbers to be //
// hold in a Queue.                                                 //
//                                                                  //
// Author: Hugo Miranda, 05/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

import appia.*;

/**
 * WaitEvent simply keeps a pair with the SendableEvent and the
 * sequence number. This structure is kept in peer info vectors
 * to keep the holding messages wether they go down (unacknowledged
 * messages) or up (out of order)
 */

class WaitingMessage {

    public appia.events.SendableEvent e;
    public int                        seqNumber;

    public WaitingMessage(appia.events.SendableEvent e,int seqNumber) {
	this.e=e;
	this.seqNumber=seqNumber;
    }
}
