
/**
 * Title:        Apia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.protocols.group;

public class LocalState {

  public ViewState vs;

  // These fields are supposed to be READ-ONLY

  public boolean[] failed;
  public int my_rank;
  public int coord;
  public boolean am_coord;

  public LocalState(ViewState vs, Endpt my_endpt) {
    int i;

    this.vs=vs;

    failed=new boolean[vs.view.length];
    for (i=failed.length-1 ; i >= 0 ; i--) {
      failed[i]=false;
    }

    my_rank=vs.getRank(my_endpt);

    coord=0;

    am_coord= (my_rank == coord);
  }

  public void fail(int rank) {
    failed[rank]=true;

    if (failed[coord] == true) {
      int i;
      for (i=coord ; (i < failed.length) && failed[i] ; i++) ;
      if (i < failed.length) {
        coord=i;
      } else {
        throw new AppiaGroupError("No Coordinator !!!!!!");
      }

      am_coord= (my_rank == coord);
    }
  }

  public String toString() {
    String s;
    int i;

    s="\nam_coord: "+am_coord+"\ncoord: "+coord+"\nmy_rank: "+my_rank+"\nfailed: [";
    for (i=0 ; i < failed.length ; i++)
        s=s+failed[i]+",";
    s=s+"]\n";

    return s;
  }

  // The following methods are available for future multi-thread support.
  // For now they aren't used.

  public synchronized boolean failed(int i) {
    return failed[i];
  }

  public synchronized void setFailed(int i) {
    failed[i]=true;
  }

  public synchronized int coord() {
    return coord;
  }

  public synchronized void setCoord(int i) {
    coord=i;
  }

  public synchronized boolean am_coord() {
    return (coord == my_rank);
  }
}