
/**
 * Title:        Apia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.protocols.group;

public class ViewID implements java.io.Serializable {

  // WARNING: these attributes should be READ ONLY
  public long ltime;
  public Endpt coord;

  public ViewID(long ltime, Endpt coord) {
    this.ltime=ltime;
    this.coord=coord;
  }

  public ViewID next() {
    return new ViewID(ltime+1,coord);
  }

  public ViewID next(Endpt new_coord) {
    return new ViewID(ltime+1,new_coord);
  }

  public ViewID merge(ViewID view_id, Endpt new_coord) {
    return new ViewID(Math.max(view_id.ltime,ltime)+1,new_coord);
  }

  public boolean equals(ViewID vid) {
    return (ltime == vid.ltime) && (coord.equals(vid.coord));
  }

  public String toString() {
    return "[ViewID:"+ltime+";"+coord.toString()+"]";
  }
}