
/**
 * Title:        Apia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.protocols.group.events;

import appia.*;
import appia.protocols.group.*;
import appia.protocols.udpsimple.InetWithPort;

public class GroupInit extends Event {

  public ViewState vs;
  public int rank;
  public InetWithPort ip_multicast;

  public GroupInit(
          ViewState vs,
          Endpt endpt,
          InetWithPort ip_multicast,
          Channel channel, Direction dir, Session source)
    throws AppiaEventException,NullPointerException,AppiaGroupException {

    super(channel,dir,source);

    if ((vs == null) || (endpt == null))
       throw new NullPointerException("appia:group:GroupInit: view state or endpoint not given");

    this.vs=vs;
    if ((rank=vs.getRank(endpt)) < 0)
       throw new AppiaGroupException("GroupInit: endpoint given doesn't belong to view");
    this.ip_multicast=ip_multicast;
  }
}