
/**
 * Title:        Apia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.protocols.group.events;

import appia.*;
import appia.events.SendableEvent;
import appia.protocols.group.*;
import appia.message.Message;

public class GroupSendableEvent extends SendableEvent implements Cloneable {

  public Group group;
  public ViewID view_id;
  public int orig;

  public GroupSendableEvent(
          Channel channel, Direction dir, Session source,
          Group group, ViewID view_id)
    throws AppiaEventException {

    super(channel,dir,source,new ObjectsMessage());
    this.group=group;
    this.view_id=view_id;
  }

  public GroupSendableEvent() {
    super(new ObjectsMessage());
  }

  public GroupSendableEvent(
          Channel channel, Direction dir, Session source,
          Group group, ViewID view_id,
          ObjectsMessage omsg)
    throws AppiaEventException {

    super(channel,dir,source,omsg);
    this.group=group;
    this.view_id=view_id;
  }

  public GroupSendableEvent(ObjectsMessage omsg) {
    super(omsg);
  }

  public Event cloneEvent() throws CloneNotSupportedException {
    GroupSendableEvent ev=(GroupSendableEvent)super.cloneEvent();
    ev.message=(ObjectsMessage)((ObjectsMessage)message).clone();
    return ev;
  }

  public void setObjectsMessage(ObjectsMessage omsg) {
    message=omsg;
  }

  public ObjectsMessage getObjectsMessage() {
    return (ObjectsMessage)message;
  }
}