package appia.protocols.prdAppl;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework            //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: ApplicationReader: User interface with Appia: thread for  //
//        reading user input                                        //
//                                                                  //
// Author: Hugo Miranda, 05/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

class PrdApplReader extends Thread {
    
    private PrdApplSession         parentSession;
    private java.io.BufferedReader keyb;
    public  String                 sComLine=null;
    private String                 local=null;

    public PrdApplReader(PrdApplSession parentSession) {
	super();
	this.parentSession=parentSession;
	keyb=new java.io.BufferedReader(new java.io.InputStreamReader(System.in));
    }

    public void run() {
	while(true) {
	    try {
		local=keyb.readLine();
		synchronized(this) {
		    parentSession.channel.makeAsync();
		    sComLine=local;
		    while(sComLine!=null)
			wait();
		}
	    }
	    catch(java.io.IOException e) {}
	    catch(InterruptedException e) {}
	    catch(appia.AppiaEventException e) {}
	}
    }
}    
