package appia.protocols.udpsimple;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework            //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: InetWithPort : Keeps inet and port address information    //
//                                                                  //
// Author: Hugo Miranda, 06/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

import appia.*;

import java.net.*;

/**
 * InetWithPort just enriches InetAddress class with an integer port number.
 */

public class InetWithPort implements java.io.Serializable {
    public InetAddress host;
    public int         port;

    public boolean equals(InetWithPort test) {
        return this.port==test.port &&
            this.host.equals(test.host);
    }
}
